JEMBean (Oracle - Berkeley DB Java Edition API)
Date: 2014-12-16

com.sleepycat.je.jmx

## Class JEMBean

- java.lang.Object
- - com.sleepycat.je.jmx.JEMBean

- All Implemented Interfaces:
    com.sleepycat.je.dbi.EnvironmentImpl.MBeanRegistrar
  Direct Known Subclasses:
    JEDiagnostics, JEMonitor

      public abstract class JEMBean
      extends Object
      implements com.sleepycat.je.dbi.EnvironmentImpl.MBeanRegistrar

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected String` | `className`
    `protected Class<?>` | `currentClass`
    `protected String` | `DESCRIPTION`
    `protected Environment` | `env`
    `protected ObjectName` | `jeName`
    `protected ArrayList<MBeanOperationInfo>` | `operationList`
    `protected MBeanServer` | `server`
    `static MBeanParameterInfo[]` | `statParams`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `` | `JEMBean()`
    `protected` | `JEMBean(Environment env)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected abstract void` | `addOperations()` Add MBean operations into the list.
    `void` | `doRegister(Environment env)` For EnvironmentImpl.MBeanRegistrar interface.
    `protected abstract void` | `doRegisterMBean(Environment env)`
    `void` | `doUnregister()` For EnvironmentImpl.MBeanRegistrar interface.
    `protected abstract MBeanAttributeInfo[]` | `getAttributeList()` Get attribute metadata for this MBean.
    `protected MBeanConstructorInfo[]` | `getConstructors()` Get constructor metadata for this MBean.
    `MBeanInfo` | `getMBeanInfo()`
    `protected MBeanNotificationInfo[]` | `getNotificationInfo()` Get notification metadata for this MBean.
    `protected StatsConfig` | `getStatsConfig(Object[] params)` Helper for creating a StatsConfig object to use as an operation parameter.
    `protected abstract void` | `initClassFields()`
    `protected void` | `resetMBeanInfo()` Create the available management interface for this environment.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### statParams

          public static final MBeanParameterInfo[] statParams

    - #### server

          protected MBeanServer server

    - #### jeName

          protected ObjectName jeName

    - #### className

          protected String className

    - #### DESCRIPTION

          protected String DESCRIPTION

    - #### currentClass

          protected Class<?> currentClass

    - #### env

          protected Environment env

    - #### operationList

          protected ArrayList<MBeanOperationInfo> operationList

  - ### Constructor Detail

    - #### JEMBean

          protected JEMBean(Environment env)

    - #### JEMBean

          public JEMBean()

  - ### Method Detail

    - #### initClassFields

          protected abstract void initClassFields()

    - #### resetMBeanInfo

          protected void resetMBeanInfo()

      Create the available management interface for this environment. The attributes and operations available vary according to environment configuration.

    - #### getAttributeList

          protected abstract MBeanAttributeInfo[] getAttributeList()

      Get attribute metadata for this MBean.
      Returns:
        array of MBeanAttributeInfo objects describing the available attributes.

    - #### addOperations

          protected abstract void addOperations()

      Add MBean operations into the list.

    - #### getConstructors

          protected MBeanConstructorInfo[] getConstructors()

      Get constructor metadata for this MBean. Since the process of getting constructors is the same for each concrete MBean, define it here to reduce coding work.
      Returns:
        array of MBeanConstructorInfo objects describing the constructor attributes.

    - #### getNotificationInfo

          protected MBeanNotificationInfo[] getNotificationInfo()

      Get notification metadata for this MBean.
      Returns:
        array of MBeanNotificationInfo describing notifications.

    - #### doRegister

          public void doRegister(Environment env)
                          throws Exception

      For EnvironmentImpl.MBeanRegistrar interface. Register this MBean with the MBeanServer.
      Specified by:
        `doRegister` in interface `com.sleepycat.je.dbi.EnvironmentImpl.MBeanRegistrar`
      Throws:
        `Exception`

    - #### doRegisterMBean

          protected abstract void doRegisterMBean(Environment env)
                                           throws Exception

      Throws:
        `Exception`

    - #### doUnregister

          public void doUnregister()
                            throws Exception

      For EnvironmentImpl.MBeanRegistrar interface. Remove this MBean from the MBeanServer.
      Specified by:
        `doUnregister` in interface `com.sleepycat.je.dbi.EnvironmentImpl.MBeanRegistrar`
      Throws:
        `Exception`

    - #### getMBeanInfo

          public MBeanInfo getMBeanInfo()

      See Also:
        `Implement the getMBeanInfo method of DynamicMBean.`

    - #### getStatsConfig

          protected StatsConfig getStatsConfig(Object[] params)

      Helper for creating a StatsConfig object to use as an operation parameter.

Copyright (c) 2004, 2014 Oracle and/or its affiliates. All rights reserved.